diff --git a/src/device/r4300/new_dynarec/arm/assem_arm.c b/src/device/r4300/new_dynarec/arm/assem_arm.c
index 81846a9d4..fde929965 100644
--- a/src/device/r4300/new_dynarec/arm/assem_arm.c
+++ b/src/device/r4300/new_dynarec/arm/assem_arm.c
@@ -3252,21 +3252,19 @@ static void shift_assemble_arm(int i,struct regstat *i_regs)
         }
         else
         {
-          // FIXME: What if shift==tl ?
-          assert(shift!=tl);
           int temp=get_reg(i_regs->regmap,-1);
           int real_th=th;
           if(th<0&&opcode2[i]!=0x14) {th=temp;} // DSLLV doesn't need a temporary register
           assert(sl>=0);
           assert(sh>=0);
+          emit_testimm(shift,32);
           emit_andimm(shift,31,HOST_TEMPREG);
           if(opcode2[i]==0x14) // DSLLV
           {
             if(th>=0) emit_shl(sh,HOST_TEMPREG,th);
             emit_rsbimm(HOST_TEMPREG,32,HOST_TEMPREG);
             emit_orrshr(sl,HOST_TEMPREG,th);
-            emit_andimm(shift,31,HOST_TEMPREG);
-            emit_testimm(shift,32);
+            emit_rsbimm(HOST_TEMPREG,32,HOST_TEMPREG);
             emit_shl(sl,HOST_TEMPREG,tl);
             if(th>=0) emit_cmovne_reg(tl,th);
             emit_cmovne_imm(0,tl);
@@ -3277,8 +3275,7 @@ static void shift_assemble_arm(int i,struct regstat *i_regs)
             emit_shr(sl,HOST_TEMPREG,tl);
             emit_rsbimm(HOST_TEMPREG,32,HOST_TEMPREG);
             emit_orrshl(sh,HOST_TEMPREG,tl);
-            emit_andimm(shift,31,HOST_TEMPREG);
-            emit_testimm(shift,32);
+            emit_rsbimm(HOST_TEMPREG,32,HOST_TEMPREG);
             emit_shr(sh,HOST_TEMPREG,th);
             emit_cmovne_reg(th,tl);
             if(real_th>=0) emit_cmovne_imm(0,th);
@@ -3293,8 +3290,7 @@ static void shift_assemble_arm(int i,struct regstat *i_regs)
               emit_sarimm(th,31,temp);
             }
             emit_orrshl(sh,HOST_TEMPREG,tl);
-            emit_andimm(shift,31,HOST_TEMPREG);
-            emit_testimm(shift,32);
+            emit_rsbimm(HOST_TEMPREG,32,HOST_TEMPREG);
             emit_sar(sh,HOST_TEMPREG,th);
             emit_cmovne_reg(th,tl);
             if(real_th>=0) emit_cmovne_reg(temp,th);
diff --git a/src/device/r4300/new_dynarec/new_dynarec.c b/src/device/r4300/new_dynarec/new_dynarec.c
index 4d3d21ec6..4fe45aca1 100644
--- a/src/device/r4300/new_dynarec/new_dynarec.c
+++ b/src/device/r4300/new_dynarec/new_dynarec.c
@@ -2682,6 +2682,7 @@ static void load_alloc(struct regstat *current,int i)
     if(opcode[i]==0x27||opcode[i]==0x37) // LWU/LD
     {
       current->is32&=~(1LL<<rt1[i]);
+      if(opcode[i]==0x27) current->uu&=~(1LL<<rt1[i]); // LWU: always alloc upper part in order to zero extend the destination register
       alloc_reg64(current,i,rt1[i]);
     }
     else if(opcode[i]==0x1A||opcode[i]==0x1B) // LDL/LDR
